/* AUTOGENERATED FILE. DO NOT EDIT. */
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "cmock.h"
#include "mock_xt_ioports.h"

static const char* CMockString_WRMSK_EXPSTATE = "WRMSK_EXPSTATE";
static const char* CMockString_WUR_EXPSTATE = "WUR_EXPSTATE";
static const char* CMockString_mask = "mask";
static const char* CMockString_v = "v";

typedef struct _CMOCK_WUR_EXPSTATE_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  unsigned int Expected_v;
  char IgnoreArg_v;

} CMOCK_WUR_EXPSTATE_CALL_INSTANCE;

typedef struct _CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  unsigned int Expected_v;
  uint32_t Expected_mask;
  char IgnoreArg_v;
  char IgnoreArg_mask;

} CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE;

static struct mock_xt_ioportsInstance
{
  char WUR_EXPSTATE_IgnoreBool;
  char WUR_EXPSTATE_CallbackBool;
  CMOCK_WUR_EXPSTATE_CALLBACK WUR_EXPSTATE_CallbackFunctionPointer;
  int WUR_EXPSTATE_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE WUR_EXPSTATE_CallInstance;
  char WRMSK_EXPSTATE_IgnoreBool;
  char WRMSK_EXPSTATE_CallbackBool;
  CMOCK_WRMSK_EXPSTATE_CALLBACK WRMSK_EXPSTATE_CallbackFunctionPointer;
  int WRMSK_EXPSTATE_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE WRMSK_EXPSTATE_CallInstance;
} Mock;

extern jmp_buf AbortFrame;

void mock_xt_ioports_Verify(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_MEM_INDEX_TYPE call_instance;
  call_instance = Mock.WUR_EXPSTATE_CallInstance;
  if (Mock.WUR_EXPSTATE_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_WUR_EXPSTATE);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.WUR_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.WRMSK_EXPSTATE_CallInstance;
  if (Mock.WRMSK_EXPSTATE_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_WRMSK_EXPSTATE);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.WRMSK_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
}

void mock_xt_ioports_Init(void)
{
  mock_xt_ioports_Destroy();
}

void mock_xt_ioports_Destroy(void)
{
  CMock_Guts_MemFreeAll();
  memset(&Mock, 0, sizeof(Mock));
}

void WUR_EXPSTATE(unsigned int v)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_WUR_EXPSTATE);
  cmock_call_instance = (CMOCK_WUR_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.WUR_EXPSTATE_CallInstance);
  Mock.WUR_EXPSTATE_CallInstance = CMock_Guts_MemNext(Mock.WUR_EXPSTATE_CallInstance);
  if (Mock.WUR_EXPSTATE_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.WUR_EXPSTATE_CallbackBool &&
      Mock.WUR_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    Mock.WUR_EXPSTATE_CallbackFunctionPointer(v, Mock.WUR_EXPSTATE_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_v)
  {
    UNITY_SET_DETAILS(CMockString_WUR_EXPSTATE,CMockString_v);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_v, v, cmock_line, CMockStringMismatch);
  }
  }
  if (Mock.WUR_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    Mock.WUR_EXPSTATE_CallbackFunctionPointer(v, Mock.WUR_EXPSTATE_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void CMockExpectParameters_WUR_EXPSTATE(CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance, unsigned int v);
void CMockExpectParameters_WUR_EXPSTATE(CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance, unsigned int v)
{
  cmock_call_instance->Expected_v = v;
  cmock_call_instance->IgnoreArg_v = 0;
}

void WUR_EXPSTATE_CMockIgnore(void)
{
  Mock.WUR_EXPSTATE_IgnoreBool = (char)1;
}

void WUR_EXPSTATE_CMockStopIgnore(void)
{
  Mock.WUR_EXPSTATE_IgnoreBool = (char)0;
}

void WUR_EXPSTATE_CMockExpectAnyArgs(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_WUR_EXPSTATE_CALL_INSTANCE));
  CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WUR_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.WUR_EXPSTATE_CallInstance = CMock_Guts_MemChain(Mock.WUR_EXPSTATE_CallInstance, cmock_guts_index);
  Mock.WUR_EXPSTATE_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void WUR_EXPSTATE_CMockExpect(UNITY_LINE_TYPE cmock_line, unsigned int v)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_WUR_EXPSTATE_CALL_INSTANCE));
  CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WUR_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.WUR_EXPSTATE_CallInstance = CMock_Guts_MemChain(Mock.WUR_EXPSTATE_CallInstance, cmock_guts_index);
  Mock.WUR_EXPSTATE_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_WUR_EXPSTATE(cmock_call_instance, v);
}

void WUR_EXPSTATE_AddCallback(CMOCK_WUR_EXPSTATE_CALLBACK Callback)
{
  Mock.WUR_EXPSTATE_IgnoreBool = (char)0;
  Mock.WUR_EXPSTATE_CallbackBool = (char)1;
  Mock.WUR_EXPSTATE_CallbackFunctionPointer = Callback;
}

void WUR_EXPSTATE_Stub(CMOCK_WUR_EXPSTATE_CALLBACK Callback)
{
  Mock.WUR_EXPSTATE_IgnoreBool = (char)0;
  Mock.WUR_EXPSTATE_CallbackBool = (char)0;
  Mock.WUR_EXPSTATE_CallbackFunctionPointer = Callback;
}

void WUR_EXPSTATE_CMockIgnoreArg_v(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_WUR_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WUR_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.WUR_EXPSTATE_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_v = 1;
}

void WRMSK_EXPSTATE(unsigned int v, uint32_t mask)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_WRMSK_EXPSTATE);
  cmock_call_instance = (CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.WRMSK_EXPSTATE_CallInstance);
  Mock.WRMSK_EXPSTATE_CallInstance = CMock_Guts_MemNext(Mock.WRMSK_EXPSTATE_CallInstance);
  if (Mock.WRMSK_EXPSTATE_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.WRMSK_EXPSTATE_CallbackBool &&
      Mock.WRMSK_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    Mock.WRMSK_EXPSTATE_CallbackFunctionPointer(v, mask, Mock.WRMSK_EXPSTATE_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_v)
  {
    UNITY_SET_DETAILS(CMockString_WRMSK_EXPSTATE,CMockString_v);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_v, v, cmock_line, CMockStringMismatch);
  }
  if (!cmock_call_instance->IgnoreArg_mask)
  {
    UNITY_SET_DETAILS(CMockString_WRMSK_EXPSTATE,CMockString_mask);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_mask, mask, cmock_line, CMockStringMismatch);
  }
  }
  if (Mock.WRMSK_EXPSTATE_CallbackFunctionPointer != NULL)
  {
    Mock.WRMSK_EXPSTATE_CallbackFunctionPointer(v, mask, Mock.WRMSK_EXPSTATE_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void CMockExpectParameters_WRMSK_EXPSTATE(CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance, unsigned int v, uint32_t mask);
void CMockExpectParameters_WRMSK_EXPSTATE(CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance, unsigned int v, uint32_t mask)
{
  cmock_call_instance->Expected_v = v;
  cmock_call_instance->IgnoreArg_v = 0;
  cmock_call_instance->Expected_mask = mask;
  cmock_call_instance->IgnoreArg_mask = 0;
}

void WRMSK_EXPSTATE_CMockIgnore(void)
{
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)1;
}

void WRMSK_EXPSTATE_CMockStopIgnore(void)
{
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)0;
}

void WRMSK_EXPSTATE_CMockExpectAnyArgs(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE));
  CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.WRMSK_EXPSTATE_CallInstance = CMock_Guts_MemChain(Mock.WRMSK_EXPSTATE_CallInstance, cmock_guts_index);
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void WRMSK_EXPSTATE_CMockExpect(UNITY_LINE_TYPE cmock_line, unsigned int v, uint32_t mask)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE));
  CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.WRMSK_EXPSTATE_CallInstance = CMock_Guts_MemChain(Mock.WRMSK_EXPSTATE_CallInstance, cmock_guts_index);
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_WRMSK_EXPSTATE(cmock_call_instance, v, mask);
}

void WRMSK_EXPSTATE_AddCallback(CMOCK_WRMSK_EXPSTATE_CALLBACK Callback)
{
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)0;
  Mock.WRMSK_EXPSTATE_CallbackBool = (char)1;
  Mock.WRMSK_EXPSTATE_CallbackFunctionPointer = Callback;
}

void WRMSK_EXPSTATE_Stub(CMOCK_WRMSK_EXPSTATE_CALLBACK Callback)
{
  Mock.WRMSK_EXPSTATE_IgnoreBool = (char)0;
  Mock.WRMSK_EXPSTATE_CallbackBool = (char)0;
  Mock.WRMSK_EXPSTATE_CallbackFunctionPointer = Callback;
}

void WRMSK_EXPSTATE_CMockIgnoreArg_v(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.WRMSK_EXPSTATE_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_v = 1;
}

void WRMSK_EXPSTATE_CMockIgnoreArg_mask(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE* cmock_call_instance = (CMOCK_WRMSK_EXPSTATE_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.WRMSK_EXPSTATE_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_mask = 1;
}

